package com.ts.als.controller;

import java.util.Collection;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import com.ts.als.model.Arp;
import com.ts.als.service.ArpService;


@RestController
public class ArpController {
	
	@Autowired
	ArpService	arpService;
	
	
	@RequestMapping(value = "api/arps", method = RequestMethod.GET, produces = org.springframework.http.MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<Collection<Arp>> getArps() {
		Collection<Arp> arps = arpService.findAll();
		return new ResponseEntity<Collection<Arp>>(arps, HttpStatus.OK);
	}

	@RequestMapping(value = "api/arp/{id}", method = RequestMethod.GET, produces = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<Arp> getArp(@PathVariable("id") Long id) {
		Arp arp = arpService.findOne(id);
		if (arp == null) {
			return new ResponseEntity<Arp>(HttpStatus.NOT_FOUND);
		}
		return new ResponseEntity<Arp>(arp, HttpStatus.OK);
	}

	@RequestMapping(value = "api/arps/{company}", method = RequestMethod.GET, produces = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<Collection<Arp>> getArp(@PathVariable("company") String company) {
		Collection<Arp> arps = arpService.findByCompany(company);
		return new ResponseEntity<Collection<Arp>>(arps, HttpStatus.OK);
	}

	@RequestMapping(value = "api/arps", method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_VALUE, produces = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<Arp> createArp(@RequestBody Arp Arp) {
		Arp savedArp = arpService.create(Arp);
		return new ResponseEntity<Arp>(savedArp, HttpStatus.CREATED);
	}

	@RequestMapping(value = "/api/arps/{id}", method = RequestMethod.PUT, consumes = MediaType.APPLICATION_JSON_VALUE, produces = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<Arp> updateArp(@RequestBody Arp Arp) {
		Arp updatedArp = arpService.update(Arp);
		if (updatedArp == null) {
			return new ResponseEntity<Arp>(HttpStatus.INTERNAL_SERVER_ERROR);
		}
		return new ResponseEntity<Arp>(updatedArp, HttpStatus.OK);
	}

	@RequestMapping(value="api/arps/{id}", 
			method=RequestMethod.DELETE, 
			consumes=MediaType.APPLICATION_JSON_VALUE, 
			produces=MediaType.APPLICATION_JSON_VALUE)
	public	ResponseEntity<Arp> deleteArp(@RequestBody Arp Arp){
		arpService.delete(Arp.getId());
		return	new ResponseEntity<Arp>(HttpStatus.NO_CONTENT);
		/*
		if(delete){
			return	new ResponseEntity<Arp>(HttpStatus.NO_CONTENT);
		}
		return	new ResponseEntity<Arp>(HttpStatus.INTERNAL_SERVER_ERROR);
		*/
		
	}
}
