package com.ts.als.service;

import java.util.Collection;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.ts.als.model.Arp;
import com.ts.als.repository.ArpRepository;

@Service
public class ArpBean implements ArpService {

	@Autowired
	private ArpRepository repository;

	@Override
	public Collection<Arp> findAll() {
		Collection<Arp> Arps = repository.findAll();
		return Arps;
	}

	@Override
	public Arp findOne(Long id) {
		Arp Arp = repository.findOne(id);
		return Arp;
	}

	@Override
	public Arp create(Arp Arp) {
		if(Arp.getId() != null){
			// id ile create olmaz
			return null;
		}
		
		Arp savedArp = repository.save(Arp);
		return savedArp;
	}

	@Override
	public Arp update(Arp Arp) {
		
		Arp ArpPersisted  = findOne(Arp.getId());
		if(ArpPersisted == null){
			return null;
		}
		Arp upgradedArp = repository.save(Arp);
		return upgradedArp;
	}

	@Override
	public void delete(Long id) {
		repository.delete(id);
	}

	@Override
	public Collection<Arp> findByCompany(String company) {
		Collection<Arp> Arps = repository.findByCompany(company);
		return Arps;
	}

}
